// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: commonmodule/commonmodule.proto

package openfmb.commonmodule;

/**
 * <pre>
 * Specialized 61850 MMTN LN class
 * </pre>
 *
 * Protobuf type {@code commonmodule.ReadingMMTN}
 */
public final class ReadingMMTN extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:commonmodule.ReadingMMTN)
    ReadingMMTNOrBuilder {
private static final long serialVersionUID = 0L;
  // Use ReadingMMTN.newBuilder() to construct.
  private ReadingMMTN(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private ReadingMMTN() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new ReadingMMTN();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ReadingMMTN_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ReadingMMTN_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.commonmodule.ReadingMMTN.class, openfmb.commonmodule.ReadingMMTN.Builder.class);
  }

  public static final int LOGICALNODE_FIELD_NUMBER = 1;
  private openfmb.commonmodule.LogicalNode logicalNode_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the logicalNode field is set.
   */
  @java.lang.Override
  public boolean hasLogicalNode() {
    return logicalNode_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
   * @return The logicalNode.
   */
  @java.lang.Override
  public openfmb.commonmodule.LogicalNode getLogicalNode() {
    return logicalNode_ == null ? openfmb.commonmodule.LogicalNode.getDefaultInstance() : logicalNode_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.LogicalNodeOrBuilder getLogicalNodeOrBuilder() {
    return logicalNode_ == null ? openfmb.commonmodule.LogicalNode.getDefaultInstance() : logicalNode_;
  }

  public static final int DMDVAH_FIELD_NUMBER = 2;
  private openfmb.commonmodule.BCR dmdVAh_;
  /**
   * <pre>
   * Apparent energy demand (direction: from busbar).
   * </pre>
   *
   * <code>.commonmodule.BCR DmdVAh = 2;</code>
   * @return Whether the dmdVAh field is set.
   */
  @java.lang.Override
  public boolean hasDmdVAh() {
    return dmdVAh_ != null;
  }
  /**
   * <pre>
   * Apparent energy demand (direction: from busbar).
   * </pre>
   *
   * <code>.commonmodule.BCR DmdVAh = 2;</code>
   * @return The dmdVAh.
   */
  @java.lang.Override
  public openfmb.commonmodule.BCR getDmdVAh() {
    return dmdVAh_ == null ? openfmb.commonmodule.BCR.getDefaultInstance() : dmdVAh_;
  }
  /**
   * <pre>
   * Apparent energy demand (direction: from busbar).
   * </pre>
   *
   * <code>.commonmodule.BCR DmdVAh = 2;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.BCROrBuilder getDmdVAhOrBuilder() {
    return dmdVAh_ == null ? openfmb.commonmodule.BCR.getDefaultInstance() : dmdVAh_;
  }

  public static final int DMDVARH_FIELD_NUMBER = 3;
  private openfmb.commonmodule.BCR dmdVArh_;
  /**
   * <pre>
   * Reactive energy demand (direction: from busbar).
   * </pre>
   *
   * <code>.commonmodule.BCR DmdVArh = 3;</code>
   * @return Whether the dmdVArh field is set.
   */
  @java.lang.Override
  public boolean hasDmdVArh() {
    return dmdVArh_ != null;
  }
  /**
   * <pre>
   * Reactive energy demand (direction: from busbar).
   * </pre>
   *
   * <code>.commonmodule.BCR DmdVArh = 3;</code>
   * @return The dmdVArh.
   */
  @java.lang.Override
  public openfmb.commonmodule.BCR getDmdVArh() {
    return dmdVArh_ == null ? openfmb.commonmodule.BCR.getDefaultInstance() : dmdVArh_;
  }
  /**
   * <pre>
   * Reactive energy demand (direction: from busbar).
   * </pre>
   *
   * <code>.commonmodule.BCR DmdVArh = 3;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.BCROrBuilder getDmdVArhOrBuilder() {
    return dmdVArh_ == null ? openfmb.commonmodule.BCR.getDefaultInstance() : dmdVArh_;
  }

  public static final int DMDWH_FIELD_NUMBER = 4;
  private openfmb.commonmodule.BCR dmdWh_;
  /**
   * <pre>
   * Real energy demand (direction: from busbar).
   * </pre>
   *
   * <code>.commonmodule.BCR DmdWh = 4;</code>
   * @return Whether the dmdWh field is set.
   */
  @java.lang.Override
  public boolean hasDmdWh() {
    return dmdWh_ != null;
  }
  /**
   * <pre>
   * Real energy demand (direction: from busbar).
   * </pre>
   *
   * <code>.commonmodule.BCR DmdWh = 4;</code>
   * @return The dmdWh.
   */
  @java.lang.Override
  public openfmb.commonmodule.BCR getDmdWh() {
    return dmdWh_ == null ? openfmb.commonmodule.BCR.getDefaultInstance() : dmdWh_;
  }
  /**
   * <pre>
   * Real energy demand (direction: from busbar).
   * </pre>
   *
   * <code>.commonmodule.BCR DmdWh = 4;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.BCROrBuilder getDmdWhOrBuilder() {
    return dmdWh_ == null ? openfmb.commonmodule.BCR.getDefaultInstance() : dmdWh_;
  }

  public static final int SUPVAH_FIELD_NUMBER = 5;
  private openfmb.commonmodule.BCR supVAh_;
  /**
   * <pre>
   * Apparent energy supply (default direction: towards busbar).
   * </pre>
   *
   * <code>.commonmodule.BCR SupVAh = 5;</code>
   * @return Whether the supVAh field is set.
   */
  @java.lang.Override
  public boolean hasSupVAh() {
    return supVAh_ != null;
  }
  /**
   * <pre>
   * Apparent energy supply (default direction: towards busbar).
   * </pre>
   *
   * <code>.commonmodule.BCR SupVAh = 5;</code>
   * @return The supVAh.
   */
  @java.lang.Override
  public openfmb.commonmodule.BCR getSupVAh() {
    return supVAh_ == null ? openfmb.commonmodule.BCR.getDefaultInstance() : supVAh_;
  }
  /**
   * <pre>
   * Apparent energy supply (default direction: towards busbar).
   * </pre>
   *
   * <code>.commonmodule.BCR SupVAh = 5;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.BCROrBuilder getSupVAhOrBuilder() {
    return supVAh_ == null ? openfmb.commonmodule.BCR.getDefaultInstance() : supVAh_;
  }

  public static final int SUPVARH_FIELD_NUMBER = 6;
  private openfmb.commonmodule.BCR supVArh_;
  /**
   * <pre>
   * Reactive energy supply (default direction: towards busbar).
   * </pre>
   *
   * <code>.commonmodule.BCR SupVArh = 6;</code>
   * @return Whether the supVArh field is set.
   */
  @java.lang.Override
  public boolean hasSupVArh() {
    return supVArh_ != null;
  }
  /**
   * <pre>
   * Reactive energy supply (default direction: towards busbar).
   * </pre>
   *
   * <code>.commonmodule.BCR SupVArh = 6;</code>
   * @return The supVArh.
   */
  @java.lang.Override
  public openfmb.commonmodule.BCR getSupVArh() {
    return supVArh_ == null ? openfmb.commonmodule.BCR.getDefaultInstance() : supVArh_;
  }
  /**
   * <pre>
   * Reactive energy supply (default direction: towards busbar).
   * </pre>
   *
   * <code>.commonmodule.BCR SupVArh = 6;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.BCROrBuilder getSupVArhOrBuilder() {
    return supVArh_ == null ? openfmb.commonmodule.BCR.getDefaultInstance() : supVArh_;
  }

  public static final int SUPWH_FIELD_NUMBER = 7;
  private openfmb.commonmodule.BCR supWh_;
  /**
   * <pre>
   * Real energy supply (default direction: towards busbar).
   * </pre>
   *
   * <code>.commonmodule.BCR SupWh = 7;</code>
   * @return Whether the supWh field is set.
   */
  @java.lang.Override
  public boolean hasSupWh() {
    return supWh_ != null;
  }
  /**
   * <pre>
   * Real energy supply (default direction: towards busbar).
   * </pre>
   *
   * <code>.commonmodule.BCR SupWh = 7;</code>
   * @return The supWh.
   */
  @java.lang.Override
  public openfmb.commonmodule.BCR getSupWh() {
    return supWh_ == null ? openfmb.commonmodule.BCR.getDefaultInstance() : supWh_;
  }
  /**
   * <pre>
   * Real energy supply (default direction: towards busbar).
   * </pre>
   *
   * <code>.commonmodule.BCR SupWh = 7;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.BCROrBuilder getSupWhOrBuilder() {
    return supWh_ == null ? openfmb.commonmodule.BCR.getDefaultInstance() : supWh_;
  }

  public static final int TOTVAH_FIELD_NUMBER = 8;
  private openfmb.commonmodule.BCR totVAh_;
  /**
   * <pre>
   * Net apparent energy since last reset.
   * </pre>
   *
   * <code>.commonmodule.BCR TotVAh = 8;</code>
   * @return Whether the totVAh field is set.
   */
  @java.lang.Override
  public boolean hasTotVAh() {
    return totVAh_ != null;
  }
  /**
   * <pre>
   * Net apparent energy since last reset.
   * </pre>
   *
   * <code>.commonmodule.BCR TotVAh = 8;</code>
   * @return The totVAh.
   */
  @java.lang.Override
  public openfmb.commonmodule.BCR getTotVAh() {
    return totVAh_ == null ? openfmb.commonmodule.BCR.getDefaultInstance() : totVAh_;
  }
  /**
   * <pre>
   * Net apparent energy since last reset.
   * </pre>
   *
   * <code>.commonmodule.BCR TotVAh = 8;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.BCROrBuilder getTotVAhOrBuilder() {
    return totVAh_ == null ? openfmb.commonmodule.BCR.getDefaultInstance() : totVAh_;
  }

  public static final int TOTVARH_FIELD_NUMBER = 9;
  private openfmb.commonmodule.BCR totVArh_;
  /**
   * <pre>
   * Net reactive energy since last reset.
   * </pre>
   *
   * <code>.commonmodule.BCR TotVArh = 9;</code>
   * @return Whether the totVArh field is set.
   */
  @java.lang.Override
  public boolean hasTotVArh() {
    return totVArh_ != null;
  }
  /**
   * <pre>
   * Net reactive energy since last reset.
   * </pre>
   *
   * <code>.commonmodule.BCR TotVArh = 9;</code>
   * @return The totVArh.
   */
  @java.lang.Override
  public openfmb.commonmodule.BCR getTotVArh() {
    return totVArh_ == null ? openfmb.commonmodule.BCR.getDefaultInstance() : totVArh_;
  }
  /**
   * <pre>
   * Net reactive energy since last reset.
   * </pre>
   *
   * <code>.commonmodule.BCR TotVArh = 9;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.BCROrBuilder getTotVArhOrBuilder() {
    return totVArh_ == null ? openfmb.commonmodule.BCR.getDefaultInstance() : totVArh_;
  }

  public static final int TOTWH_FIELD_NUMBER = 10;
  private openfmb.commonmodule.BCR totWh_;
  /**
   * <pre>
   * Net real energy since last reset.
   * </pre>
   *
   * <code>.commonmodule.BCR TotWh = 10;</code>
   * @return Whether the totWh field is set.
   */
  @java.lang.Override
  public boolean hasTotWh() {
    return totWh_ != null;
  }
  /**
   * <pre>
   * Net real energy since last reset.
   * </pre>
   *
   * <code>.commonmodule.BCR TotWh = 10;</code>
   * @return The totWh.
   */
  @java.lang.Override
  public openfmb.commonmodule.BCR getTotWh() {
    return totWh_ == null ? openfmb.commonmodule.BCR.getDefaultInstance() : totWh_;
  }
  /**
   * <pre>
   * Net real energy since last reset.
   * </pre>
   *
   * <code>.commonmodule.BCR TotWh = 10;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.BCROrBuilder getTotWhOrBuilder() {
    return totWh_ == null ? openfmb.commonmodule.BCR.getDefaultInstance() : totWh_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (logicalNode_ != null) {
      output.writeMessage(1, getLogicalNode());
    }
    if (dmdVAh_ != null) {
      output.writeMessage(2, getDmdVAh());
    }
    if (dmdVArh_ != null) {
      output.writeMessage(3, getDmdVArh());
    }
    if (dmdWh_ != null) {
      output.writeMessage(4, getDmdWh());
    }
    if (supVAh_ != null) {
      output.writeMessage(5, getSupVAh());
    }
    if (supVArh_ != null) {
      output.writeMessage(6, getSupVArh());
    }
    if (supWh_ != null) {
      output.writeMessage(7, getSupWh());
    }
    if (totVAh_ != null) {
      output.writeMessage(8, getTotVAh());
    }
    if (totVArh_ != null) {
      output.writeMessage(9, getTotVArh());
    }
    if (totWh_ != null) {
      output.writeMessage(10, getTotWh());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (logicalNode_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getLogicalNode());
    }
    if (dmdVAh_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getDmdVAh());
    }
    if (dmdVArh_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getDmdVArh());
    }
    if (dmdWh_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(4, getDmdWh());
    }
    if (supVAh_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(5, getSupVAh());
    }
    if (supVArh_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(6, getSupVArh());
    }
    if (supWh_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(7, getSupWh());
    }
    if (totVAh_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(8, getTotVAh());
    }
    if (totVArh_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(9, getTotVArh());
    }
    if (totWh_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(10, getTotWh());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.commonmodule.ReadingMMTN)) {
      return super.equals(obj);
    }
    openfmb.commonmodule.ReadingMMTN other = (openfmb.commonmodule.ReadingMMTN) obj;

    if (hasLogicalNode() != other.hasLogicalNode()) return false;
    if (hasLogicalNode()) {
      if (!getLogicalNode()
          .equals(other.getLogicalNode())) return false;
    }
    if (hasDmdVAh() != other.hasDmdVAh()) return false;
    if (hasDmdVAh()) {
      if (!getDmdVAh()
          .equals(other.getDmdVAh())) return false;
    }
    if (hasDmdVArh() != other.hasDmdVArh()) return false;
    if (hasDmdVArh()) {
      if (!getDmdVArh()
          .equals(other.getDmdVArh())) return false;
    }
    if (hasDmdWh() != other.hasDmdWh()) return false;
    if (hasDmdWh()) {
      if (!getDmdWh()
          .equals(other.getDmdWh())) return false;
    }
    if (hasSupVAh() != other.hasSupVAh()) return false;
    if (hasSupVAh()) {
      if (!getSupVAh()
          .equals(other.getSupVAh())) return false;
    }
    if (hasSupVArh() != other.hasSupVArh()) return false;
    if (hasSupVArh()) {
      if (!getSupVArh()
          .equals(other.getSupVArh())) return false;
    }
    if (hasSupWh() != other.hasSupWh()) return false;
    if (hasSupWh()) {
      if (!getSupWh()
          .equals(other.getSupWh())) return false;
    }
    if (hasTotVAh() != other.hasTotVAh()) return false;
    if (hasTotVAh()) {
      if (!getTotVAh()
          .equals(other.getTotVAh())) return false;
    }
    if (hasTotVArh() != other.hasTotVArh()) return false;
    if (hasTotVArh()) {
      if (!getTotVArh()
          .equals(other.getTotVArh())) return false;
    }
    if (hasTotWh() != other.hasTotWh()) return false;
    if (hasTotWh()) {
      if (!getTotWh()
          .equals(other.getTotWh())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasLogicalNode()) {
      hash = (37 * hash) + LOGICALNODE_FIELD_NUMBER;
      hash = (53 * hash) + getLogicalNode().hashCode();
    }
    if (hasDmdVAh()) {
      hash = (37 * hash) + DMDVAH_FIELD_NUMBER;
      hash = (53 * hash) + getDmdVAh().hashCode();
    }
    if (hasDmdVArh()) {
      hash = (37 * hash) + DMDVARH_FIELD_NUMBER;
      hash = (53 * hash) + getDmdVArh().hashCode();
    }
    if (hasDmdWh()) {
      hash = (37 * hash) + DMDWH_FIELD_NUMBER;
      hash = (53 * hash) + getDmdWh().hashCode();
    }
    if (hasSupVAh()) {
      hash = (37 * hash) + SUPVAH_FIELD_NUMBER;
      hash = (53 * hash) + getSupVAh().hashCode();
    }
    if (hasSupVArh()) {
      hash = (37 * hash) + SUPVARH_FIELD_NUMBER;
      hash = (53 * hash) + getSupVArh().hashCode();
    }
    if (hasSupWh()) {
      hash = (37 * hash) + SUPWH_FIELD_NUMBER;
      hash = (53 * hash) + getSupWh().hashCode();
    }
    if (hasTotVAh()) {
      hash = (37 * hash) + TOTVAH_FIELD_NUMBER;
      hash = (53 * hash) + getTotVAh().hashCode();
    }
    if (hasTotVArh()) {
      hash = (37 * hash) + TOTVARH_FIELD_NUMBER;
      hash = (53 * hash) + getTotVArh().hashCode();
    }
    if (hasTotWh()) {
      hash = (37 * hash) + TOTWH_FIELD_NUMBER;
      hash = (53 * hash) + getTotWh().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.commonmodule.ReadingMMTN parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.ReadingMMTN parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.ReadingMMTN parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.ReadingMMTN parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.ReadingMMTN parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.ReadingMMTN parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.ReadingMMTN parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.ReadingMMTN parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.ReadingMMTN parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.ReadingMMTN parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.ReadingMMTN parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.ReadingMMTN parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.commonmodule.ReadingMMTN prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Specialized 61850 MMTN LN class
   * </pre>
   *
   * Protobuf type {@code commonmodule.ReadingMMTN}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:commonmodule.ReadingMMTN)
      openfmb.commonmodule.ReadingMMTNOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ReadingMMTN_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ReadingMMTN_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.commonmodule.ReadingMMTN.class, openfmb.commonmodule.ReadingMMTN.Builder.class);
    }

    // Construct using openfmb.commonmodule.ReadingMMTN.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      logicalNode_ = null;
      if (logicalNodeBuilder_ != null) {
        logicalNodeBuilder_.dispose();
        logicalNodeBuilder_ = null;
      }
      dmdVAh_ = null;
      if (dmdVAhBuilder_ != null) {
        dmdVAhBuilder_.dispose();
        dmdVAhBuilder_ = null;
      }
      dmdVArh_ = null;
      if (dmdVArhBuilder_ != null) {
        dmdVArhBuilder_.dispose();
        dmdVArhBuilder_ = null;
      }
      dmdWh_ = null;
      if (dmdWhBuilder_ != null) {
        dmdWhBuilder_.dispose();
        dmdWhBuilder_ = null;
      }
      supVAh_ = null;
      if (supVAhBuilder_ != null) {
        supVAhBuilder_.dispose();
        supVAhBuilder_ = null;
      }
      supVArh_ = null;
      if (supVArhBuilder_ != null) {
        supVArhBuilder_.dispose();
        supVArhBuilder_ = null;
      }
      supWh_ = null;
      if (supWhBuilder_ != null) {
        supWhBuilder_.dispose();
        supWhBuilder_ = null;
      }
      totVAh_ = null;
      if (totVAhBuilder_ != null) {
        totVAhBuilder_.dispose();
        totVAhBuilder_ = null;
      }
      totVArh_ = null;
      if (totVArhBuilder_ != null) {
        totVArhBuilder_.dispose();
        totVArhBuilder_ = null;
      }
      totWh_ = null;
      if (totWhBuilder_ != null) {
        totWhBuilder_.dispose();
        totWhBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ReadingMMTN_descriptor;
    }

    @java.lang.Override
    public openfmb.commonmodule.ReadingMMTN getDefaultInstanceForType() {
      return openfmb.commonmodule.ReadingMMTN.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.commonmodule.ReadingMMTN build() {
      openfmb.commonmodule.ReadingMMTN result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.commonmodule.ReadingMMTN buildPartial() {
      openfmb.commonmodule.ReadingMMTN result = new openfmb.commonmodule.ReadingMMTN(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.commonmodule.ReadingMMTN result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.logicalNode_ = logicalNodeBuilder_ == null
            ? logicalNode_
            : logicalNodeBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.dmdVAh_ = dmdVAhBuilder_ == null
            ? dmdVAh_
            : dmdVAhBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.dmdVArh_ = dmdVArhBuilder_ == null
            ? dmdVArh_
            : dmdVArhBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000008) != 0)) {
        result.dmdWh_ = dmdWhBuilder_ == null
            ? dmdWh_
            : dmdWhBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000010) != 0)) {
        result.supVAh_ = supVAhBuilder_ == null
            ? supVAh_
            : supVAhBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000020) != 0)) {
        result.supVArh_ = supVArhBuilder_ == null
            ? supVArh_
            : supVArhBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000040) != 0)) {
        result.supWh_ = supWhBuilder_ == null
            ? supWh_
            : supWhBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000080) != 0)) {
        result.totVAh_ = totVAhBuilder_ == null
            ? totVAh_
            : totVAhBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000100) != 0)) {
        result.totVArh_ = totVArhBuilder_ == null
            ? totVArh_
            : totVArhBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000200) != 0)) {
        result.totWh_ = totWhBuilder_ == null
            ? totWh_
            : totWhBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.commonmodule.ReadingMMTN) {
        return mergeFrom((openfmb.commonmodule.ReadingMMTN)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.commonmodule.ReadingMMTN other) {
      if (other == openfmb.commonmodule.ReadingMMTN.getDefaultInstance()) return this;
      if (other.hasLogicalNode()) {
        mergeLogicalNode(other.getLogicalNode());
      }
      if (other.hasDmdVAh()) {
        mergeDmdVAh(other.getDmdVAh());
      }
      if (other.hasDmdVArh()) {
        mergeDmdVArh(other.getDmdVArh());
      }
      if (other.hasDmdWh()) {
        mergeDmdWh(other.getDmdWh());
      }
      if (other.hasSupVAh()) {
        mergeSupVAh(other.getSupVAh());
      }
      if (other.hasSupVArh()) {
        mergeSupVArh(other.getSupVArh());
      }
      if (other.hasSupWh()) {
        mergeSupWh(other.getSupWh());
      }
      if (other.hasTotVAh()) {
        mergeTotVAh(other.getTotVAh());
      }
      if (other.hasTotVArh()) {
        mergeTotVArh(other.getTotVArh());
      }
      if (other.hasTotWh()) {
        mergeTotWh(other.getTotWh());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getLogicalNodeFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getDmdVAhFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getDmdVArhFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            case 34: {
              input.readMessage(
                  getDmdWhFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000008;
              break;
            } // case 34
            case 42: {
              input.readMessage(
                  getSupVAhFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000010;
              break;
            } // case 42
            case 50: {
              input.readMessage(
                  getSupVArhFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000020;
              break;
            } // case 50
            case 58: {
              input.readMessage(
                  getSupWhFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000040;
              break;
            } // case 58
            case 66: {
              input.readMessage(
                  getTotVAhFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000080;
              break;
            } // case 66
            case 74: {
              input.readMessage(
                  getTotVArhFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000100;
              break;
            } // case 74
            case 82: {
              input.readMessage(
                  getTotWhFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000200;
              break;
            } // case 82
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.LogicalNode logicalNode_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.LogicalNode, openfmb.commonmodule.LogicalNode.Builder, openfmb.commonmodule.LogicalNodeOrBuilder> logicalNodeBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the logicalNode field is set.
     */
    public boolean hasLogicalNode() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     * @return The logicalNode.
     */
    public openfmb.commonmodule.LogicalNode getLogicalNode() {
      if (logicalNodeBuilder_ == null) {
        return logicalNode_ == null ? openfmb.commonmodule.LogicalNode.getDefaultInstance() : logicalNode_;
      } else {
        return logicalNodeBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setLogicalNode(openfmb.commonmodule.LogicalNode value) {
      if (logicalNodeBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        logicalNode_ = value;
      } else {
        logicalNodeBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setLogicalNode(
        openfmb.commonmodule.LogicalNode.Builder builderForValue) {
      if (logicalNodeBuilder_ == null) {
        logicalNode_ = builderForValue.build();
      } else {
        logicalNodeBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeLogicalNode(openfmb.commonmodule.LogicalNode value) {
      if (logicalNodeBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          logicalNode_ != null &&
          logicalNode_ != openfmb.commonmodule.LogicalNode.getDefaultInstance()) {
          getLogicalNodeBuilder().mergeFrom(value);
        } else {
          logicalNode_ = value;
        }
      } else {
        logicalNodeBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearLogicalNode() {
      bitField0_ = (bitField0_ & ~0x00000001);
      logicalNode_ = null;
      if (logicalNodeBuilder_ != null) {
        logicalNodeBuilder_.dispose();
        logicalNodeBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.LogicalNode.Builder getLogicalNodeBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getLogicalNodeFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.LogicalNodeOrBuilder getLogicalNodeOrBuilder() {
      if (logicalNodeBuilder_ != null) {
        return logicalNodeBuilder_.getMessageOrBuilder();
      } else {
        return logicalNode_ == null ?
            openfmb.commonmodule.LogicalNode.getDefaultInstance() : logicalNode_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.LogicalNode, openfmb.commonmodule.LogicalNode.Builder, openfmb.commonmodule.LogicalNodeOrBuilder> 
        getLogicalNodeFieldBuilder() {
      if (logicalNodeBuilder_ == null) {
        logicalNodeBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.LogicalNode, openfmb.commonmodule.LogicalNode.Builder, openfmb.commonmodule.LogicalNodeOrBuilder>(
                getLogicalNode(),
                getParentForChildren(),
                isClean());
        logicalNode_ = null;
      }
      return logicalNodeBuilder_;
    }

    private openfmb.commonmodule.BCR dmdVAh_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.BCR, openfmb.commonmodule.BCR.Builder, openfmb.commonmodule.BCROrBuilder> dmdVAhBuilder_;
    /**
     * <pre>
     * Apparent energy demand (direction: from busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR DmdVAh = 2;</code>
     * @return Whether the dmdVAh field is set.
     */
    public boolean hasDmdVAh() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * Apparent energy demand (direction: from busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR DmdVAh = 2;</code>
     * @return The dmdVAh.
     */
    public openfmb.commonmodule.BCR getDmdVAh() {
      if (dmdVAhBuilder_ == null) {
        return dmdVAh_ == null ? openfmb.commonmodule.BCR.getDefaultInstance() : dmdVAh_;
      } else {
        return dmdVAhBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Apparent energy demand (direction: from busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR DmdVAh = 2;</code>
     */
    public Builder setDmdVAh(openfmb.commonmodule.BCR value) {
      if (dmdVAhBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        dmdVAh_ = value;
      } else {
        dmdVAhBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Apparent energy demand (direction: from busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR DmdVAh = 2;</code>
     */
    public Builder setDmdVAh(
        openfmb.commonmodule.BCR.Builder builderForValue) {
      if (dmdVAhBuilder_ == null) {
        dmdVAh_ = builderForValue.build();
      } else {
        dmdVAhBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Apparent energy demand (direction: from busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR DmdVAh = 2;</code>
     */
    public Builder mergeDmdVAh(openfmb.commonmodule.BCR value) {
      if (dmdVAhBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          dmdVAh_ != null &&
          dmdVAh_ != openfmb.commonmodule.BCR.getDefaultInstance()) {
          getDmdVAhBuilder().mergeFrom(value);
        } else {
          dmdVAh_ = value;
        }
      } else {
        dmdVAhBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Apparent energy demand (direction: from busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR DmdVAh = 2;</code>
     */
    public Builder clearDmdVAh() {
      bitField0_ = (bitField0_ & ~0x00000002);
      dmdVAh_ = null;
      if (dmdVAhBuilder_ != null) {
        dmdVAhBuilder_.dispose();
        dmdVAhBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Apparent energy demand (direction: from busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR DmdVAh = 2;</code>
     */
    public openfmb.commonmodule.BCR.Builder getDmdVAhBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getDmdVAhFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Apparent energy demand (direction: from busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR DmdVAh = 2;</code>
     */
    public openfmb.commonmodule.BCROrBuilder getDmdVAhOrBuilder() {
      if (dmdVAhBuilder_ != null) {
        return dmdVAhBuilder_.getMessageOrBuilder();
      } else {
        return dmdVAh_ == null ?
            openfmb.commonmodule.BCR.getDefaultInstance() : dmdVAh_;
      }
    }
    /**
     * <pre>
     * Apparent energy demand (direction: from busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR DmdVAh = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.BCR, openfmb.commonmodule.BCR.Builder, openfmb.commonmodule.BCROrBuilder> 
        getDmdVAhFieldBuilder() {
      if (dmdVAhBuilder_ == null) {
        dmdVAhBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.BCR, openfmb.commonmodule.BCR.Builder, openfmb.commonmodule.BCROrBuilder>(
                getDmdVAh(),
                getParentForChildren(),
                isClean());
        dmdVAh_ = null;
      }
      return dmdVAhBuilder_;
    }

    private openfmb.commonmodule.BCR dmdVArh_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.BCR, openfmb.commonmodule.BCR.Builder, openfmb.commonmodule.BCROrBuilder> dmdVArhBuilder_;
    /**
     * <pre>
     * Reactive energy demand (direction: from busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR DmdVArh = 3;</code>
     * @return Whether the dmdVArh field is set.
     */
    public boolean hasDmdVArh() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * Reactive energy demand (direction: from busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR DmdVArh = 3;</code>
     * @return The dmdVArh.
     */
    public openfmb.commonmodule.BCR getDmdVArh() {
      if (dmdVArhBuilder_ == null) {
        return dmdVArh_ == null ? openfmb.commonmodule.BCR.getDefaultInstance() : dmdVArh_;
      } else {
        return dmdVArhBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Reactive energy demand (direction: from busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR DmdVArh = 3;</code>
     */
    public Builder setDmdVArh(openfmb.commonmodule.BCR value) {
      if (dmdVArhBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        dmdVArh_ = value;
      } else {
        dmdVArhBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Reactive energy demand (direction: from busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR DmdVArh = 3;</code>
     */
    public Builder setDmdVArh(
        openfmb.commonmodule.BCR.Builder builderForValue) {
      if (dmdVArhBuilder_ == null) {
        dmdVArh_ = builderForValue.build();
      } else {
        dmdVArhBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Reactive energy demand (direction: from busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR DmdVArh = 3;</code>
     */
    public Builder mergeDmdVArh(openfmb.commonmodule.BCR value) {
      if (dmdVArhBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          dmdVArh_ != null &&
          dmdVArh_ != openfmb.commonmodule.BCR.getDefaultInstance()) {
          getDmdVArhBuilder().mergeFrom(value);
        } else {
          dmdVArh_ = value;
        }
      } else {
        dmdVArhBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Reactive energy demand (direction: from busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR DmdVArh = 3;</code>
     */
    public Builder clearDmdVArh() {
      bitField0_ = (bitField0_ & ~0x00000004);
      dmdVArh_ = null;
      if (dmdVArhBuilder_ != null) {
        dmdVArhBuilder_.dispose();
        dmdVArhBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Reactive energy demand (direction: from busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR DmdVArh = 3;</code>
     */
    public openfmb.commonmodule.BCR.Builder getDmdVArhBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getDmdVArhFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Reactive energy demand (direction: from busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR DmdVArh = 3;</code>
     */
    public openfmb.commonmodule.BCROrBuilder getDmdVArhOrBuilder() {
      if (dmdVArhBuilder_ != null) {
        return dmdVArhBuilder_.getMessageOrBuilder();
      } else {
        return dmdVArh_ == null ?
            openfmb.commonmodule.BCR.getDefaultInstance() : dmdVArh_;
      }
    }
    /**
     * <pre>
     * Reactive energy demand (direction: from busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR DmdVArh = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.BCR, openfmb.commonmodule.BCR.Builder, openfmb.commonmodule.BCROrBuilder> 
        getDmdVArhFieldBuilder() {
      if (dmdVArhBuilder_ == null) {
        dmdVArhBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.BCR, openfmb.commonmodule.BCR.Builder, openfmb.commonmodule.BCROrBuilder>(
                getDmdVArh(),
                getParentForChildren(),
                isClean());
        dmdVArh_ = null;
      }
      return dmdVArhBuilder_;
    }

    private openfmb.commonmodule.BCR dmdWh_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.BCR, openfmb.commonmodule.BCR.Builder, openfmb.commonmodule.BCROrBuilder> dmdWhBuilder_;
    /**
     * <pre>
     * Real energy demand (direction: from busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR DmdWh = 4;</code>
     * @return Whether the dmdWh field is set.
     */
    public boolean hasDmdWh() {
      return ((bitField0_ & 0x00000008) != 0);
    }
    /**
     * <pre>
     * Real energy demand (direction: from busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR DmdWh = 4;</code>
     * @return The dmdWh.
     */
    public openfmb.commonmodule.BCR getDmdWh() {
      if (dmdWhBuilder_ == null) {
        return dmdWh_ == null ? openfmb.commonmodule.BCR.getDefaultInstance() : dmdWh_;
      } else {
        return dmdWhBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Real energy demand (direction: from busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR DmdWh = 4;</code>
     */
    public Builder setDmdWh(openfmb.commonmodule.BCR value) {
      if (dmdWhBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        dmdWh_ = value;
      } else {
        dmdWhBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Real energy demand (direction: from busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR DmdWh = 4;</code>
     */
    public Builder setDmdWh(
        openfmb.commonmodule.BCR.Builder builderForValue) {
      if (dmdWhBuilder_ == null) {
        dmdWh_ = builderForValue.build();
      } else {
        dmdWhBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Real energy demand (direction: from busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR DmdWh = 4;</code>
     */
    public Builder mergeDmdWh(openfmb.commonmodule.BCR value) {
      if (dmdWhBuilder_ == null) {
        if (((bitField0_ & 0x00000008) != 0) &&
          dmdWh_ != null &&
          dmdWh_ != openfmb.commonmodule.BCR.getDefaultInstance()) {
          getDmdWhBuilder().mergeFrom(value);
        } else {
          dmdWh_ = value;
        }
      } else {
        dmdWhBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Real energy demand (direction: from busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR DmdWh = 4;</code>
     */
    public Builder clearDmdWh() {
      bitField0_ = (bitField0_ & ~0x00000008);
      dmdWh_ = null;
      if (dmdWhBuilder_ != null) {
        dmdWhBuilder_.dispose();
        dmdWhBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Real energy demand (direction: from busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR DmdWh = 4;</code>
     */
    public openfmb.commonmodule.BCR.Builder getDmdWhBuilder() {
      bitField0_ |= 0x00000008;
      onChanged();
      return getDmdWhFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Real energy demand (direction: from busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR DmdWh = 4;</code>
     */
    public openfmb.commonmodule.BCROrBuilder getDmdWhOrBuilder() {
      if (dmdWhBuilder_ != null) {
        return dmdWhBuilder_.getMessageOrBuilder();
      } else {
        return dmdWh_ == null ?
            openfmb.commonmodule.BCR.getDefaultInstance() : dmdWh_;
      }
    }
    /**
     * <pre>
     * Real energy demand (direction: from busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR DmdWh = 4;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.BCR, openfmb.commonmodule.BCR.Builder, openfmb.commonmodule.BCROrBuilder> 
        getDmdWhFieldBuilder() {
      if (dmdWhBuilder_ == null) {
        dmdWhBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.BCR, openfmb.commonmodule.BCR.Builder, openfmb.commonmodule.BCROrBuilder>(
                getDmdWh(),
                getParentForChildren(),
                isClean());
        dmdWh_ = null;
      }
      return dmdWhBuilder_;
    }

    private openfmb.commonmodule.BCR supVAh_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.BCR, openfmb.commonmodule.BCR.Builder, openfmb.commonmodule.BCROrBuilder> supVAhBuilder_;
    /**
     * <pre>
     * Apparent energy supply (default direction: towards busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR SupVAh = 5;</code>
     * @return Whether the supVAh field is set.
     */
    public boolean hasSupVAh() {
      return ((bitField0_ & 0x00000010) != 0);
    }
    /**
     * <pre>
     * Apparent energy supply (default direction: towards busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR SupVAh = 5;</code>
     * @return The supVAh.
     */
    public openfmb.commonmodule.BCR getSupVAh() {
      if (supVAhBuilder_ == null) {
        return supVAh_ == null ? openfmb.commonmodule.BCR.getDefaultInstance() : supVAh_;
      } else {
        return supVAhBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Apparent energy supply (default direction: towards busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR SupVAh = 5;</code>
     */
    public Builder setSupVAh(openfmb.commonmodule.BCR value) {
      if (supVAhBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        supVAh_ = value;
      } else {
        supVAhBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Apparent energy supply (default direction: towards busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR SupVAh = 5;</code>
     */
    public Builder setSupVAh(
        openfmb.commonmodule.BCR.Builder builderForValue) {
      if (supVAhBuilder_ == null) {
        supVAh_ = builderForValue.build();
      } else {
        supVAhBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Apparent energy supply (default direction: towards busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR SupVAh = 5;</code>
     */
    public Builder mergeSupVAh(openfmb.commonmodule.BCR value) {
      if (supVAhBuilder_ == null) {
        if (((bitField0_ & 0x00000010) != 0) &&
          supVAh_ != null &&
          supVAh_ != openfmb.commonmodule.BCR.getDefaultInstance()) {
          getSupVAhBuilder().mergeFrom(value);
        } else {
          supVAh_ = value;
        }
      } else {
        supVAhBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Apparent energy supply (default direction: towards busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR SupVAh = 5;</code>
     */
    public Builder clearSupVAh() {
      bitField0_ = (bitField0_ & ~0x00000010);
      supVAh_ = null;
      if (supVAhBuilder_ != null) {
        supVAhBuilder_.dispose();
        supVAhBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Apparent energy supply (default direction: towards busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR SupVAh = 5;</code>
     */
    public openfmb.commonmodule.BCR.Builder getSupVAhBuilder() {
      bitField0_ |= 0x00000010;
      onChanged();
      return getSupVAhFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Apparent energy supply (default direction: towards busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR SupVAh = 5;</code>
     */
    public openfmb.commonmodule.BCROrBuilder getSupVAhOrBuilder() {
      if (supVAhBuilder_ != null) {
        return supVAhBuilder_.getMessageOrBuilder();
      } else {
        return supVAh_ == null ?
            openfmb.commonmodule.BCR.getDefaultInstance() : supVAh_;
      }
    }
    /**
     * <pre>
     * Apparent energy supply (default direction: towards busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR SupVAh = 5;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.BCR, openfmb.commonmodule.BCR.Builder, openfmb.commonmodule.BCROrBuilder> 
        getSupVAhFieldBuilder() {
      if (supVAhBuilder_ == null) {
        supVAhBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.BCR, openfmb.commonmodule.BCR.Builder, openfmb.commonmodule.BCROrBuilder>(
                getSupVAh(),
                getParentForChildren(),
                isClean());
        supVAh_ = null;
      }
      return supVAhBuilder_;
    }

    private openfmb.commonmodule.BCR supVArh_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.BCR, openfmb.commonmodule.BCR.Builder, openfmb.commonmodule.BCROrBuilder> supVArhBuilder_;
    /**
     * <pre>
     * Reactive energy supply (default direction: towards busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR SupVArh = 6;</code>
     * @return Whether the supVArh field is set.
     */
    public boolean hasSupVArh() {
      return ((bitField0_ & 0x00000020) != 0);
    }
    /**
     * <pre>
     * Reactive energy supply (default direction: towards busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR SupVArh = 6;</code>
     * @return The supVArh.
     */
    public openfmb.commonmodule.BCR getSupVArh() {
      if (supVArhBuilder_ == null) {
        return supVArh_ == null ? openfmb.commonmodule.BCR.getDefaultInstance() : supVArh_;
      } else {
        return supVArhBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Reactive energy supply (default direction: towards busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR SupVArh = 6;</code>
     */
    public Builder setSupVArh(openfmb.commonmodule.BCR value) {
      if (supVArhBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        supVArh_ = value;
      } else {
        supVArhBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Reactive energy supply (default direction: towards busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR SupVArh = 6;</code>
     */
    public Builder setSupVArh(
        openfmb.commonmodule.BCR.Builder builderForValue) {
      if (supVArhBuilder_ == null) {
        supVArh_ = builderForValue.build();
      } else {
        supVArhBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Reactive energy supply (default direction: towards busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR SupVArh = 6;</code>
     */
    public Builder mergeSupVArh(openfmb.commonmodule.BCR value) {
      if (supVArhBuilder_ == null) {
        if (((bitField0_ & 0x00000020) != 0) &&
          supVArh_ != null &&
          supVArh_ != openfmb.commonmodule.BCR.getDefaultInstance()) {
          getSupVArhBuilder().mergeFrom(value);
        } else {
          supVArh_ = value;
        }
      } else {
        supVArhBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Reactive energy supply (default direction: towards busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR SupVArh = 6;</code>
     */
    public Builder clearSupVArh() {
      bitField0_ = (bitField0_ & ~0x00000020);
      supVArh_ = null;
      if (supVArhBuilder_ != null) {
        supVArhBuilder_.dispose();
        supVArhBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Reactive energy supply (default direction: towards busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR SupVArh = 6;</code>
     */
    public openfmb.commonmodule.BCR.Builder getSupVArhBuilder() {
      bitField0_ |= 0x00000020;
      onChanged();
      return getSupVArhFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Reactive energy supply (default direction: towards busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR SupVArh = 6;</code>
     */
    public openfmb.commonmodule.BCROrBuilder getSupVArhOrBuilder() {
      if (supVArhBuilder_ != null) {
        return supVArhBuilder_.getMessageOrBuilder();
      } else {
        return supVArh_ == null ?
            openfmb.commonmodule.BCR.getDefaultInstance() : supVArh_;
      }
    }
    /**
     * <pre>
     * Reactive energy supply (default direction: towards busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR SupVArh = 6;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.BCR, openfmb.commonmodule.BCR.Builder, openfmb.commonmodule.BCROrBuilder> 
        getSupVArhFieldBuilder() {
      if (supVArhBuilder_ == null) {
        supVArhBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.BCR, openfmb.commonmodule.BCR.Builder, openfmb.commonmodule.BCROrBuilder>(
                getSupVArh(),
                getParentForChildren(),
                isClean());
        supVArh_ = null;
      }
      return supVArhBuilder_;
    }

    private openfmb.commonmodule.BCR supWh_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.BCR, openfmb.commonmodule.BCR.Builder, openfmb.commonmodule.BCROrBuilder> supWhBuilder_;
    /**
     * <pre>
     * Real energy supply (default direction: towards busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR SupWh = 7;</code>
     * @return Whether the supWh field is set.
     */
    public boolean hasSupWh() {
      return ((bitField0_ & 0x00000040) != 0);
    }
    /**
     * <pre>
     * Real energy supply (default direction: towards busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR SupWh = 7;</code>
     * @return The supWh.
     */
    public openfmb.commonmodule.BCR getSupWh() {
      if (supWhBuilder_ == null) {
        return supWh_ == null ? openfmb.commonmodule.BCR.getDefaultInstance() : supWh_;
      } else {
        return supWhBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Real energy supply (default direction: towards busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR SupWh = 7;</code>
     */
    public Builder setSupWh(openfmb.commonmodule.BCR value) {
      if (supWhBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        supWh_ = value;
      } else {
        supWhBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000040;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Real energy supply (default direction: towards busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR SupWh = 7;</code>
     */
    public Builder setSupWh(
        openfmb.commonmodule.BCR.Builder builderForValue) {
      if (supWhBuilder_ == null) {
        supWh_ = builderForValue.build();
      } else {
        supWhBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000040;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Real energy supply (default direction: towards busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR SupWh = 7;</code>
     */
    public Builder mergeSupWh(openfmb.commonmodule.BCR value) {
      if (supWhBuilder_ == null) {
        if (((bitField0_ & 0x00000040) != 0) &&
          supWh_ != null &&
          supWh_ != openfmb.commonmodule.BCR.getDefaultInstance()) {
          getSupWhBuilder().mergeFrom(value);
        } else {
          supWh_ = value;
        }
      } else {
        supWhBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000040;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Real energy supply (default direction: towards busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR SupWh = 7;</code>
     */
    public Builder clearSupWh() {
      bitField0_ = (bitField0_ & ~0x00000040);
      supWh_ = null;
      if (supWhBuilder_ != null) {
        supWhBuilder_.dispose();
        supWhBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Real energy supply (default direction: towards busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR SupWh = 7;</code>
     */
    public openfmb.commonmodule.BCR.Builder getSupWhBuilder() {
      bitField0_ |= 0x00000040;
      onChanged();
      return getSupWhFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Real energy supply (default direction: towards busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR SupWh = 7;</code>
     */
    public openfmb.commonmodule.BCROrBuilder getSupWhOrBuilder() {
      if (supWhBuilder_ != null) {
        return supWhBuilder_.getMessageOrBuilder();
      } else {
        return supWh_ == null ?
            openfmb.commonmodule.BCR.getDefaultInstance() : supWh_;
      }
    }
    /**
     * <pre>
     * Real energy supply (default direction: towards busbar).
     * </pre>
     *
     * <code>.commonmodule.BCR SupWh = 7;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.BCR, openfmb.commonmodule.BCR.Builder, openfmb.commonmodule.BCROrBuilder> 
        getSupWhFieldBuilder() {
      if (supWhBuilder_ == null) {
        supWhBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.BCR, openfmb.commonmodule.BCR.Builder, openfmb.commonmodule.BCROrBuilder>(
                getSupWh(),
                getParentForChildren(),
                isClean());
        supWh_ = null;
      }
      return supWhBuilder_;
    }

    private openfmb.commonmodule.BCR totVAh_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.BCR, openfmb.commonmodule.BCR.Builder, openfmb.commonmodule.BCROrBuilder> totVAhBuilder_;
    /**
     * <pre>
     * Net apparent energy since last reset.
     * </pre>
     *
     * <code>.commonmodule.BCR TotVAh = 8;</code>
     * @return Whether the totVAh field is set.
     */
    public boolean hasTotVAh() {
      return ((bitField0_ & 0x00000080) != 0);
    }
    /**
     * <pre>
     * Net apparent energy since last reset.
     * </pre>
     *
     * <code>.commonmodule.BCR TotVAh = 8;</code>
     * @return The totVAh.
     */
    public openfmb.commonmodule.BCR getTotVAh() {
      if (totVAhBuilder_ == null) {
        return totVAh_ == null ? openfmb.commonmodule.BCR.getDefaultInstance() : totVAh_;
      } else {
        return totVAhBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Net apparent energy since last reset.
     * </pre>
     *
     * <code>.commonmodule.BCR TotVAh = 8;</code>
     */
    public Builder setTotVAh(openfmb.commonmodule.BCR value) {
      if (totVAhBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        totVAh_ = value;
      } else {
        totVAhBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000080;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Net apparent energy since last reset.
     * </pre>
     *
     * <code>.commonmodule.BCR TotVAh = 8;</code>
     */
    public Builder setTotVAh(
        openfmb.commonmodule.BCR.Builder builderForValue) {
      if (totVAhBuilder_ == null) {
        totVAh_ = builderForValue.build();
      } else {
        totVAhBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000080;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Net apparent energy since last reset.
     * </pre>
     *
     * <code>.commonmodule.BCR TotVAh = 8;</code>
     */
    public Builder mergeTotVAh(openfmb.commonmodule.BCR value) {
      if (totVAhBuilder_ == null) {
        if (((bitField0_ & 0x00000080) != 0) &&
          totVAh_ != null &&
          totVAh_ != openfmb.commonmodule.BCR.getDefaultInstance()) {
          getTotVAhBuilder().mergeFrom(value);
        } else {
          totVAh_ = value;
        }
      } else {
        totVAhBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000080;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Net apparent energy since last reset.
     * </pre>
     *
     * <code>.commonmodule.BCR TotVAh = 8;</code>
     */
    public Builder clearTotVAh() {
      bitField0_ = (bitField0_ & ~0x00000080);
      totVAh_ = null;
      if (totVAhBuilder_ != null) {
        totVAhBuilder_.dispose();
        totVAhBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Net apparent energy since last reset.
     * </pre>
     *
     * <code>.commonmodule.BCR TotVAh = 8;</code>
     */
    public openfmb.commonmodule.BCR.Builder getTotVAhBuilder() {
      bitField0_ |= 0x00000080;
      onChanged();
      return getTotVAhFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Net apparent energy since last reset.
     * </pre>
     *
     * <code>.commonmodule.BCR TotVAh = 8;</code>
     */
    public openfmb.commonmodule.BCROrBuilder getTotVAhOrBuilder() {
      if (totVAhBuilder_ != null) {
        return totVAhBuilder_.getMessageOrBuilder();
      } else {
        return totVAh_ == null ?
            openfmb.commonmodule.BCR.getDefaultInstance() : totVAh_;
      }
    }
    /**
     * <pre>
     * Net apparent energy since last reset.
     * </pre>
     *
     * <code>.commonmodule.BCR TotVAh = 8;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.BCR, openfmb.commonmodule.BCR.Builder, openfmb.commonmodule.BCROrBuilder> 
        getTotVAhFieldBuilder() {
      if (totVAhBuilder_ == null) {
        totVAhBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.BCR, openfmb.commonmodule.BCR.Builder, openfmb.commonmodule.BCROrBuilder>(
                getTotVAh(),
                getParentForChildren(),
                isClean());
        totVAh_ = null;
      }
      return totVAhBuilder_;
    }

    private openfmb.commonmodule.BCR totVArh_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.BCR, openfmb.commonmodule.BCR.Builder, openfmb.commonmodule.BCROrBuilder> totVArhBuilder_;
    /**
     * <pre>
     * Net reactive energy since last reset.
     * </pre>
     *
     * <code>.commonmodule.BCR TotVArh = 9;</code>
     * @return Whether the totVArh field is set.
     */
    public boolean hasTotVArh() {
      return ((bitField0_ & 0x00000100) != 0);
    }
    /**
     * <pre>
     * Net reactive energy since last reset.
     * </pre>
     *
     * <code>.commonmodule.BCR TotVArh = 9;</code>
     * @return The totVArh.
     */
    public openfmb.commonmodule.BCR getTotVArh() {
      if (totVArhBuilder_ == null) {
        return totVArh_ == null ? openfmb.commonmodule.BCR.getDefaultInstance() : totVArh_;
      } else {
        return totVArhBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Net reactive energy since last reset.
     * </pre>
     *
     * <code>.commonmodule.BCR TotVArh = 9;</code>
     */
    public Builder setTotVArh(openfmb.commonmodule.BCR value) {
      if (totVArhBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        totVArh_ = value;
      } else {
        totVArhBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000100;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Net reactive energy since last reset.
     * </pre>
     *
     * <code>.commonmodule.BCR TotVArh = 9;</code>
     */
    public Builder setTotVArh(
        openfmb.commonmodule.BCR.Builder builderForValue) {
      if (totVArhBuilder_ == null) {
        totVArh_ = builderForValue.build();
      } else {
        totVArhBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000100;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Net reactive energy since last reset.
     * </pre>
     *
     * <code>.commonmodule.BCR TotVArh = 9;</code>
     */
    public Builder mergeTotVArh(openfmb.commonmodule.BCR value) {
      if (totVArhBuilder_ == null) {
        if (((bitField0_ & 0x00000100) != 0) &&
          totVArh_ != null &&
          totVArh_ != openfmb.commonmodule.BCR.getDefaultInstance()) {
          getTotVArhBuilder().mergeFrom(value);
        } else {
          totVArh_ = value;
        }
      } else {
        totVArhBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000100;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Net reactive energy since last reset.
     * </pre>
     *
     * <code>.commonmodule.BCR TotVArh = 9;</code>
     */
    public Builder clearTotVArh() {
      bitField0_ = (bitField0_ & ~0x00000100);
      totVArh_ = null;
      if (totVArhBuilder_ != null) {
        totVArhBuilder_.dispose();
        totVArhBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Net reactive energy since last reset.
     * </pre>
     *
     * <code>.commonmodule.BCR TotVArh = 9;</code>
     */
    public openfmb.commonmodule.BCR.Builder getTotVArhBuilder() {
      bitField0_ |= 0x00000100;
      onChanged();
      return getTotVArhFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Net reactive energy since last reset.
     * </pre>
     *
     * <code>.commonmodule.BCR TotVArh = 9;</code>
     */
    public openfmb.commonmodule.BCROrBuilder getTotVArhOrBuilder() {
      if (totVArhBuilder_ != null) {
        return totVArhBuilder_.getMessageOrBuilder();
      } else {
        return totVArh_ == null ?
            openfmb.commonmodule.BCR.getDefaultInstance() : totVArh_;
      }
    }
    /**
     * <pre>
     * Net reactive energy since last reset.
     * </pre>
     *
     * <code>.commonmodule.BCR TotVArh = 9;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.BCR, openfmb.commonmodule.BCR.Builder, openfmb.commonmodule.BCROrBuilder> 
        getTotVArhFieldBuilder() {
      if (totVArhBuilder_ == null) {
        totVArhBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.BCR, openfmb.commonmodule.BCR.Builder, openfmb.commonmodule.BCROrBuilder>(
                getTotVArh(),
                getParentForChildren(),
                isClean());
        totVArh_ = null;
      }
      return totVArhBuilder_;
    }

    private openfmb.commonmodule.BCR totWh_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.BCR, openfmb.commonmodule.BCR.Builder, openfmb.commonmodule.BCROrBuilder> totWhBuilder_;
    /**
     * <pre>
     * Net real energy since last reset.
     * </pre>
     *
     * <code>.commonmodule.BCR TotWh = 10;</code>
     * @return Whether the totWh field is set.
     */
    public boolean hasTotWh() {
      return ((bitField0_ & 0x00000200) != 0);
    }
    /**
     * <pre>
     * Net real energy since last reset.
     * </pre>
     *
     * <code>.commonmodule.BCR TotWh = 10;</code>
     * @return The totWh.
     */
    public openfmb.commonmodule.BCR getTotWh() {
      if (totWhBuilder_ == null) {
        return totWh_ == null ? openfmb.commonmodule.BCR.getDefaultInstance() : totWh_;
      } else {
        return totWhBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Net real energy since last reset.
     * </pre>
     *
     * <code>.commonmodule.BCR TotWh = 10;</code>
     */
    public Builder setTotWh(openfmb.commonmodule.BCR value) {
      if (totWhBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        totWh_ = value;
      } else {
        totWhBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000200;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Net real energy since last reset.
     * </pre>
     *
     * <code>.commonmodule.BCR TotWh = 10;</code>
     */
    public Builder setTotWh(
        openfmb.commonmodule.BCR.Builder builderForValue) {
      if (totWhBuilder_ == null) {
        totWh_ = builderForValue.build();
      } else {
        totWhBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000200;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Net real energy since last reset.
     * </pre>
     *
     * <code>.commonmodule.BCR TotWh = 10;</code>
     */
    public Builder mergeTotWh(openfmb.commonmodule.BCR value) {
      if (totWhBuilder_ == null) {
        if (((bitField0_ & 0x00000200) != 0) &&
          totWh_ != null &&
          totWh_ != openfmb.commonmodule.BCR.getDefaultInstance()) {
          getTotWhBuilder().mergeFrom(value);
        } else {
          totWh_ = value;
        }
      } else {
        totWhBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000200;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Net real energy since last reset.
     * </pre>
     *
     * <code>.commonmodule.BCR TotWh = 10;</code>
     */
    public Builder clearTotWh() {
      bitField0_ = (bitField0_ & ~0x00000200);
      totWh_ = null;
      if (totWhBuilder_ != null) {
        totWhBuilder_.dispose();
        totWhBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Net real energy since last reset.
     * </pre>
     *
     * <code>.commonmodule.BCR TotWh = 10;</code>
     */
    public openfmb.commonmodule.BCR.Builder getTotWhBuilder() {
      bitField0_ |= 0x00000200;
      onChanged();
      return getTotWhFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Net real energy since last reset.
     * </pre>
     *
     * <code>.commonmodule.BCR TotWh = 10;</code>
     */
    public openfmb.commonmodule.BCROrBuilder getTotWhOrBuilder() {
      if (totWhBuilder_ != null) {
        return totWhBuilder_.getMessageOrBuilder();
      } else {
        return totWh_ == null ?
            openfmb.commonmodule.BCR.getDefaultInstance() : totWh_;
      }
    }
    /**
     * <pre>
     * Net real energy since last reset.
     * </pre>
     *
     * <code>.commonmodule.BCR TotWh = 10;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.BCR, openfmb.commonmodule.BCR.Builder, openfmb.commonmodule.BCROrBuilder> 
        getTotWhFieldBuilder() {
      if (totWhBuilder_ == null) {
        totWhBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.BCR, openfmb.commonmodule.BCR.Builder, openfmb.commonmodule.BCROrBuilder>(
                getTotWh(),
                getParentForChildren(),
                isClean());
        totWh_ = null;
      }
      return totWhBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:commonmodule.ReadingMMTN)
  }

  // @@protoc_insertion_point(class_scope:commonmodule.ReadingMMTN)
  private static final openfmb.commonmodule.ReadingMMTN DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.commonmodule.ReadingMMTN();
  }

  public static openfmb.commonmodule.ReadingMMTN getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<ReadingMMTN>
      PARSER = new com.google.protobuf.AbstractParser<ReadingMMTN>() {
    @java.lang.Override
    public ReadingMMTN parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<ReadingMMTN> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<ReadingMMTN> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.commonmodule.ReadingMMTN getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

